<?php
namespace Opencart\Catalog\Controller\Extension\Edfapay\Payment;
class Edfapay extends \Opencart\System\Engine\Controller {

	public function index() {
		$this->load->language('extension/edfapay/payment/edfapay');
		

		$data['language'] = $this->config->get('config_language');

		return $this->load->view('extension/edfapay/payment/edfapay', $data);
	}

	/**
	 * @return void
	 */
	public function confirm(): void {
		$json = array();
		// $this->load->language('extension/edfapay/payment/edfapay');

		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$order_number      = $this->session->data['order_id'];
		$order_amount      = $order_info['total'];
		$order_currency    = 'SAR';
		$order_description = 'Order ID#' .$this->session->data['order_id'];
		$password          = $this->config->get('payment_edfapay_hash');


		// Concatenate the values
		$concatenated_string = $order_number . $order_amount . $order_currency . $order_description . $password;
		$md5Hash             = md5(strtoupper($concatenated_string));
    	$hash_data           = sha1($md5Hash);

		$this->session->data['hash'] = $hash_data;
		$this->session->data['order_id'] = $order_number;

		if($order_info){

			$post_data = array(
				'action'           => 'SALE',
				'edfa_merchant_id' => $this->config->get('payment_edfapay_merchant'),
				'order_id'         => $this->session->data['order_id'],
				'order_amount'     => $order_info['total'],
				'order_currency'   => 'SAR',
				'order_description'=> 'Order ID#' .$this->session->data['order_id'],
				'req_token'        => 'N',
				'payer_first_name' => $order_info['firstname'],
				'payer_last_name'  => $order_info['lastname'],
				'payer_address'    => $order_info['shipping_address_1'],
				'payer_country'    => $order_info['shipping_iso_code_2'],
				// 'payer_country'    => $order_info['iso_code_2'],
				'payer_city'       => $order_info['shipping_city'],
				'payer_zip'        => $order_info['shipping_postcode'],
				'payer_email'      => $order_info['email'],
				'payer_phone'      => $order_info['telephone'],
				'payer_ip' 		   => $order_info['ip'],
			//	'payer_ip' 		   => '176.44.76.222',
				// 'term_url_3ds' => 'https://successorfailurl.com',
				'term_url_3ds'     => $this->url->link('extension/edfapay/payment/edfapay.return' ."&order_id=".$this->session->data['order_id']. "&hash=".$hash_data, '', true),
				'auth' 			   => 'N',
				'recurring_init'   => 'N',
				'hash'             => $hash_data
			);

// 			var_dump($post_data);
// exit();


			$curl = curl_init();

			curl_setopt_array(
				$curl, array(
					CURLOPT_URL   		   => 'https://api.edfapay.com/payment/initiate',
					CURLOPT_RETURNTRANSFER => true,
					CURLOPT_ENCODING 	   => '',
					CURLOPT_MAXREDIRS 	   => 10,
					CURLOPT_TIMEOUT 	   => 0,
					CURLOPT_FOLLOWLOCATION => true,
					CURLOPT_HTTP_VERSION   => CURL_HTTP_VERSION_1_1,
					CURLOPT_CUSTOMREQUEST  => 'POST',
					CURLOPT_POSTFIELDS     => http_build_query($post_data),
			));

			$response = curl_exec($curl);

			curl_close($curl);

			$json_decode = json_decode($response,true);
		
		  //  var_dump($json_decode);


			if ($json_decode && isset($json_decode['redirect_url'])) {
				$json['redirect'] = $json_decode['redirect_url'];
				
			}
			else{
				$json['error'] = $json_decode['responseBody'];
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}



	public function return ()
    {
        $this->load->model('checkout/order');

        $curl = curl_init();
        
        if (isset($this->request->get['order_id']) && isset($this->request->get['hash'])) {
            $order_id = $this->request->get['order_id'];
            $hash =$this->request->get['hash'];
            
            $check_data = array(
            'order_id'         => $order_id,
            'merchant_id' => $this->config->get('payment_edfapay_merchant'),
            'hash' 			   => $hash,
        );
        

            
        }else{
            
             $this->session->data["error"] = "Something Went Wrong";
        $this->response->redirect($this->url->link('checkout/checkout', '', true));
            
        }
		

   



        curl_setopt_array(
            $curl,
            array(
                CURLOPT_URL            => 'https://api.edfapay.com/payment/status',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING       => '',
                CURLOPT_MAXREDIRS      => 10,
                CURLOPT_TIMEOUT        => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION  => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS    => json_encode($check_data),
                CURLOPT_HTTPHEADER    => array(
                    'Content-Type: application/json'
                ),
            )
        );

        $response = curl_exec($curl);
        

        curl_close($curl);
        if ($response === false) {
            echo 'Curl error: ' . curl_error($curl);
            exit();
        }
        $json = json_decode($response, true);

        $response = $json['responseBody'];

        $response_data = json_decode($response, true);
		


        if (isset($response_data['status'])) {
            if ($response_data['status'] === 'decline') {
                $this->model_checkout_order->addHistory($order_id, $this->config->get('payment_edfapay_decline_order_status_id'), $response_data['reason']);
                $order_status = 2;
                $comment_data = $response_data['reason'];
            } elseif ($response_data['status'] === 'settled') {
                $this->model_checkout_order->addHistory($order_id, $this->config->get('payment_edfapay_order_status_id'), "Payment Successful");
                $order_status = 1;
                $comment_data = "Payment Successful";
            } else {
                $this->model_checkout_order->addHistory($order_id, $this->config->get('payment_edfapay_pending_order_status_id'), $response_data['reason']);
                $order_status = 0;
                $comment_data = $response_data['reason'];
            }
        }
	

        $sql = "INSERT INTO " . DB_PREFIX . "edfapay_transaction (
            `edfapay_transaction_order_id`, 
            `edfapay_transaction_hash`, 
            `edfapay_transaction_status`, 
            `edfapay_transaction_comment`, 
            `edfapay_transaction_payment_id`
            ) VALUES 
            (
                '" . $order_id . "',
                 '" . $hash . "',
                  '" . $order_status . "',
                   '" . $comment_data . "',
                    '" . $response_data['payment_id'] . "'
                    )";

        $this->db->query($sql);

        // redirect to success page
        $this->session->data["success"] = "Payment Successful";
        $this->response->redirect($this->url->link('checkout/success', '', true));
    }

	



	
}

